/*
 * Copyright (C) 2013 Snowsun <http://wyrez.org> and contributors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package org.wyrez.shootingstars.states;

import com.jme3.app.state.AbstractAppState;
import com.jme3.app.state.AppStateManager;
import com.jme3.asset.AssetManager;
import com.sun.jna.Memory;
import java.io.File;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.wyrez.baseio.config.FlatFileConfig;
import org.wyrez.shootingstars.data.YTDownloader;
import org.wyrez.shootingstars.game.GameSettings;
import org.wyrez.shootingstars.gui.YTDownloadGUI;
import org.wyrez.shootingstars.gui.listener.YTDownloadListener;
import org.wyrez.shootingstars.helper.PathHelper;
import org.wyrez.shootingstars.helper.ScreenHelper;
import tonegod.gui.core.Screen;
import uk.co.caprica.vlcj.player.MediaPlayerFactory;
import uk.co.caprica.vlcj.player.direct.BufferFormat;
import uk.co.caprica.vlcj.player.direct.DirectMediaPlayer;
import uk.co.caprica.vlcj.player.direct.RenderCallback;

/**
 *
 * @author Snowsun
 */
public class YTDownloadState extends AbstractAppState implements YTDownloadListener {

    private static final int SLEEP = 1000;
    private static final String META_EXTENSION = ".meta";
    private static final String KEY_TITLE = "Title";
    private static final String KEY_ARTIST = "Artist";
    private static final Pattern YT_LINK_PATTERN = Pattern.compile("\\?v=[^\\&]*\\&??");
    /**/
    private StateManager stateManager;
    private GameSettings settings;
    private YTDownloadGUI gui;
    private YTDownloader downloader;

    public YTDownloadState(Screen screen, StateManager stateManager,
            GameSettings settings, YTDownloader downloader, ScreenHelper screenHelper,
            AssetManager assetManager) {
        this.stateManager = stateManager;
        this.settings = settings;
        this.gui = new YTDownloadGUI(screen, this, screenHelper, assetManager);
        this.downloader = downloader;
    }

    @Override
    public void stateAttached(AppStateManager stateManager) {
        gui.attach();
    }

    @Override
    public void stateDetached(AppStateManager stateManager) {
        gui.detach();
    }

    public void downloadYTVideo(String url) {
        try {
            Matcher matcher = YT_LINK_PATTERN.matcher(url);
            String identifier = "";
            if (matcher.find()) {
                identifier = matcher.group().replace("?v=", "");
            } else {
                //TODO add error message
                stateManager.setState(State.MENU);
            }
            String path;
            if ((path = getVideoCache(identifier)) == null) {
                downloader.download(url, PathHelper.getCacheFolder());
                String targetPath = downloader.getLastTarget().getPath();
                path = PathHelper.getCacheFolder() + identifier
                        + targetPath.substring(targetPath.lastIndexOf("."), targetPath.length());
                new File(targetPath).renameTo(new File(path));
                createMetadataFile(path);
            }
            settings.setVideoFile(path);
            readMetadata();
            stateManager.setState(State.FILEMETAINFO);
        } catch (Exception ex) {
            stateManager.setState(State.MENU);
        }
    }

    private String getVideoCache(String identifier) {
        File[] cachedFiles = new File(PathHelper.getCacheFolder()).listFiles();
        for (File file : cachedFiles) {
            if (file.getName().substring(0, file.getName().lastIndexOf(".")).equals(identifier)) {
                return file.getPath();
            }
        }
        return null;
    }

    private void createMetadataFile(String file) {
        FlatFileConfig config = new FlatFileConfig(file + META_EXTENSION);
        config.putString(KEY_TITLE, downloader.getLastTitle());
        config.putString(KEY_ARTIST, "Youtube download");
        config.save();
    }

    private void readMetadata() {
        MediaPlayerFactory mediaPlayerFactory = new MediaPlayerFactory("--no-video-title-show", "--quiet");
        DirectMediaPlayer mediaPlayer = mediaPlayerFactory.newDirectMediaPlayer(1, 1, new RenderCallback() {
            public void display(DirectMediaPlayer dmp, Memory[] memorys, BufferFormat bf) {
            }
        });
        mediaPlayer.setVolume(0);
        mediaPlayer.prepareMedia(settings.getVideoFile());
        mediaPlayer.play();
        try {
            Thread.sleep(SLEEP);
        } catch (Exception ex) {
        }
        FlatFileConfig config = new FlatFileConfig(settings.getVideoFile() + META_EXTENSION);
        settings.setTrackTitle(config.getString(KEY_TITLE));
        settings.setTrackArtist(config.getString(KEY_ARTIST));

        settings.useVideo(mediaPlayer.getVideoTrackCount() > 0);
        settings.setTrackLength(Math.round((float) mediaPlayer.getLength() / 1000f));

        mediaPlayer.stop();
        mediaPlayer.release();
        mediaPlayerFactory.release();
    }

    public void cancel() {
        stateManager.setState(State.MENU);
    }
}
